/*
 * ##################################################### Start DataLoggerPage #####################################################
 */
function DataLoggerPage() {
  this.dataLoggerArchiveEntries = undefined;
  this.dataLoggerArchiveEntriesUpdated = false;
  this.dataLoggerArchiveEntriesHash = undefined;

  if (!(this instanceof DataLoggerPage)) {
    return new DataLoggerPage();
  }
  PageTemplate.call(this);
  var thisClass = this;

  this.prepare = function() {
    if (!thisClass.contentSection) {
      thisClass.contentSection = document.createElement('div');
      var header = document.createElement('h3');
      header.setAttribute('class', 'h3');
      header.appendChild(document.createTextNode(i18n.translate('data_logger')));
      thisClass.contentSection.appendChild(header);
      thisClass.contentSection.appendChild(document.createTextNode(i18n.translate('data_logger_configuration_note')));
      thisClass.contentSection.appendChild(document.createElement('br'));
      thisClass.contentSection.appendChild(document.createElement('br'));
      thisClass.contentSection.appendChild(document.createTextNode(i18n.translate('sd_card_status') + ': '));
      var sdState = document.createTextNode('');
      thisClass.contentSection.appendChild(sdState);

      thisClass.contentSection.appendChild(document.createElement('br'));
      thisClass.contentSection.appendChild(document.createElement('br'));

      var divSpinnerWaitForData = document.createElement('div');
      divSpinnerWaitForData.setAttribute('class', 'spinner');
      divSpinnerWaitForData.setAttribute('id', 'WaitForData');
      thisClass.contentSection.appendChild(divSpinnerWaitForData);
 
      var archiveHeader = document.createElement('h3');
      archiveHeader.appendChild(document.createTextNode(i18n.translate('content')));
      archiveHeader.setAttribute('id', 'ArchiveHeader');
      archiveHeader.setAttribute('hidden', '');
      thisClass.contentSection.appendChild(archiveHeader);

      var dataLoggerArchiveEntriesList = document.createElement('div');
      dataLoggerArchiveEntriesList.setAttribute('container', '');
      dataLoggerArchiveEntriesList.setAttribute('id', 'DataLoggerArchiveEntries');
      thisClass.contentSection.appendChild(dataLoggerArchiveEntriesList);
      thisClass.contentSection.appendChild(document.createElement('br'));

      thisClass.dataBindings.push(function() {
        if (thisClass.dataLoggerArchiveEntriesUpdated === undefined || thisClass.dataLoggerArchiveEntriesUpdated) {
          thisClass.dataLoggerArchiveEntriesUpdated = false;
          var newArchiveEntries = document.createElement('div');
          newArchiveEntries.setAttribute('container', '');
          newArchiveEntries.setAttribute('id', 'DataLoggerArchiveEntries');
          if (thisClass.dataLoggerArchiveEntries) {
            thisClass.addArchiveColumns(newArchiveEntries);
            document.getElementById('WaitForData').setAttribute('hidden', '');
            document.getElementById('ArchiveHeader').removeAttribute('hidden');
          } else {
            document.getElementById('WaitForData').removeAttribute('hidden');
            document.getElementById('ArchiveHeader').setAttribute('hidden', '');
          }
          var oldNode = document.getElementById('DataLoggerArchiveEntries');
          var parent = oldNode.parentNode;
          parent.replaceChild(newArchiveEntries, oldNode);
        }
        if (mainSite.deviceInfo.SdCardPresent) {
          sdState.nodeValue = i18n.translate('sd_card_status_active').replace(/SDCARDUSAGE|SDCARDSIZE/gi,
              function(subst) {
                switch (subst) {
                  case 'SDCARDUSAGE':
                    return mainSite.deviceInfo.SdCardUsage;
                  case 'SDCARDSIZE':
                    return mainSite.deviceInfo.SdCardSize;
                }
              }) + ' ';
        } else {
          sdState.nodeValue = i18n.translate("sd_card_status_not_present");
        }
      });
    }
    mainSite.main.appendChild(thisClass.contentSection);
    thisClass.requestData();
    thisClass.update();
    thisClass.setFocus();
  }

  this.addArchiveColumns = function(parent) {
    if (thisClass.dataLoggerArchiveEntries) {
      thisClass.dataLoggerArchiveEntries.years.sort(function(a, b) { return b.year - a.year });
      thisClass.dataLoggerArchiveEntries.years.forEach(function(year_entry) {
        var year = document.createElement('div');
        year.setAttribute('row', '');
        year.setAttribute('id', 'year'+year_entry.year);
        var yearHeader = document.createElement('div');
        yearHeader.setAttribute('column', '4');
        var yearName = document.createElement('h4');
        var expandYearLink = createGlyphIconElement('a', 'plus', 'black');
        expandYearLink.setAttribute('style', 'padding-left:1.2em; font-size:1.5em');
        expandYearLink.appendChild(document.createTextNode(year_entry.year));
        expandYearLink.pseudoStyle('before', 'font-size', '0.8em');
        yearName.appendChild(expandYearLink);
        yearHeader.appendChild(yearName);
        year.appendChild(yearHeader);
        var months = document.createElement('div');
        months.setAttribute('container', '');
        months.setAttribute('id', 'month-'+year_entry.year);
        months.setAttribute('hidden', '');
        expandYearLink.onclick = function() {
          var thisMonths = months;
          if (thisMonths.hasAttribute('hidden')) {
            thisMonths.removeAttribute('hidden');
            this.classList.remove('plus');
            this.classList.add('minus');
          } else {
            thisMonths.setAttribute('hidden', '');
            this.classList.remove('minus');
            this.classList.add('plus');
          }
          this.blur();
        }
        year_entry.months.sort(function(a, b) {
          if (a.name < b.name) {
            return -1;
          }
          if (a.name > b.name) {
            return 1;
          }
          return 0;
        });
        year_entry.months.reverse();
        var year_size = 0;
        year_entry.months.forEach(function(month_entry) {
          year_size += month_entry.size;
          if (month_entry.size > 0) {
            var month = document.createElement('div');
            month.setAttribute('row', '');
            month.setAttribute('id', 'month'+ month_entry.name);
            var monthSpacer = document.createElement('div');
            monthSpacer.setAttribute('column', '1');
            var monthHeader = document.createElement('div');
            monthHeader.setAttribute('column', '2');
            var monthDownload = document.createElement('div');
            monthDownload.setAttribute('column', '2');
            var monthName = document.createElement('b')
            var expandMonthLink = createGlyphIconElement('a', 'plus', 'black');
            expandMonthLink.setAttribute('style', 'padding-left:1.25em; font-size:1em');
            expandMonthLink.appendChild(document.createTextNode(month_entry.name));
            expandMonthLink.pseudoStyle('before', 'font-size', '0.8em');
            expandMonthLink.pseudoStyle('before', 'position', 'relative');
            monthName.appendChild(expandMonthLink);
            var monthDownloadContent = document.createElement('b');
            monthDownloadContent.appendChild(document.createTextNode(thisClass.convertFileSize(month_entry.size)));
            monthDownloadContent.setAttribute('style', 'padding-left:2.7em');
            monthHeader.appendChild(monthName);
            monthDownload.appendChild(monthDownloadContent);
            month.appendChild(monthSpacer);
            month.appendChild(monthHeader);
            month.appendChild(monthDownload);
            var days = document.createElement('div');
            days.setAttribute('container', '');
            days.setAttribute('id', 'days-'+month_entry.name);
            days.setAttribute('hidden', '');
            expandMonthLink.onclick = function() {
              var thisDays = days;
              if (thisDays.hasAttribute('hidden')) {
                thisDays.removeAttribute('hidden');
                this.classList.remove('plus');
                this.classList.add('minus');
              } else {
                thisDays.setAttribute('hidden', '');
                this.classList.remove('minus');
                this.classList.add('plus');
              }
              this.blur();
            }
            months.appendChild(month);
            months.appendChild(days);
            month_entry.days.sort(function(a, b) {
              if (a.path < b.path) {
                return -1;
              }
              if (a.path > b.path) {
                return 1;
              }
              return 0;
            });
            month_entry.days.reverse();
            month_entry.days.forEach(function(day_entry) {
              var dayname = day_entry.path.substring(day_entry.path.indexOf(year_entry.year)).replace(/\//g, '-');
              var files = document.createElement('div');
              files.setAttribute('container', '');
              files.setAttribute('id', 'files-'+dayname);
              day_entry.files.sort(function(a, b) {
                if (a.name < b.name) {
                  return -1;
                }
                if (a.name > b.name) {
                  return 1;
                }
                return 0;
              });
              day_entry.files.forEach(function(file_entry) {
                var file = document.createElement('div');
                file.setAttribute('row', '');
                var fileSpacer = document.createElement('div');
                fileSpacer.setAttribute('column', '3');
                var fileName = document.createElement('div');
                fileName.setAttribute('column', '2');
                var fileDownload = document.createElement('div');
                fileDownload.setAttribute('column', '2');
                fileName.appendChild(document.createElement('p'));
                fileName.firstChild.appendChild(document.createTextNode(file_entry.name));
                fileName.firstChild.setAttribute('style', 'padding-left:0.5em');
                var fileLink = createGlyphIconElement('a', 'download', 'black');
                fileLink.setAttribute('style', 'margin-left: 2em; padding-left:0em; font-size:1em');
                fileLink.pseudoStyle('before', 'font-size', '1.2em');
                fileLink.pseudoStyle('before', 'position', 'relative');
                fileLink.appendChild(document.createTextNode(thisClass.convertFileSize(file_entry.size)));
                fileDownload.appendChild(fileLink);
                fileLink.onclick = function() {
                    var dialog = new ModalSpinnerDialog(i18n.translate('data_logger') + ' - ' + i18n.translate('download_logs'), i18n.translate('download_logs_started'));
                    dialog.prepare();
                    this.id = 'DownloadLoggerFile';
                    thisClass.downloadLoggerFile(day_entry.path+'/'+file_entry.name, dialog);
                }
                file.appendChild(fileSpacer);
                file.appendChild(fileName);
                file.appendChild(fileDownload);
                files.appendChild(file);
              });
              days.appendChild(files);
            });
          }
        });
        if (year_size > 0) {
          parent.appendChild(year);
          parent.appendChild(months);
        }
      });
    }
  }

  this.convertFileSize = function(size) {
    if (size < 2) {
      return size + " " + i18n.translate('t_byte');
    } else if (size < 1024) {
      return size + " " + i18n.translate('t_bytes');
    } else if (size < 2048000) {
      return (size/1024).toFixed(1) + " " + i18n.translate('t_kbyte');
    } else {
      return (size/1024/1024).toFixed(1) + " " + i18n.translate('t_mbyte');
    }
  }
  
  this.downloadLoggerFile = function(filename, dialog) {
    IscWebService('getDownloadLink', {'filename' : filename}, function(response) {
      if (response == undefined) {                                                  
        DisplayError(response);
        return;
      }
      if (response.error) {
        DisplayError(response);
        return;
      }
      var link = document.createElement('a');
      var filepath = response.data.URL.split('/');
      var name = filepath[filepath.length -1];
      link.setAttribute("href", response.data.URL);
      link.appendChild(document.createTextNode(i18n.translate('click_here')));
      link.setAttribute("download", name);
      dialog.showDone(i18n.translate('download_logs_finished'));
      dialog.modalBody.appendChild(link);
      link.click();
    });
  }  

  this.setDataLoggerArchiveEntries = function(response) {
    if (response && response.data && response.data.years.length) {
      var newHash = forge.md.md5.create().update(response.data).digest().toHex();
      thisClass.dataLoggerArchiveEntriesUpdated = !(thisClass.dataLoggerArchiveEntriesHash == newHash);
      if (thisClass.dataLoggerArchiveEntriesUpdated) {
        thisClass.dataLoggerArchiveEntriesHash = newHash;
        thisClass.dataLoggerArchiveEntries = response.data;
      }
    } else {
      // no data received
      thisClass.dataLoggerArchiveEntriesUpdated = true;
      thisClass.dataLoggerArchiveEntriesHash = undefined;
      thisClass.dataLoggerArchiveEntries = undefined;
    }
  }

  this.setFocus = function() {
  };

  this.requestData = function() {
    mainSite.timer.getDeviceInfo.oneShot();

    if (!mainSite.timer.getDataLoggerArchiveEntries) {
      mainSite.timer.getDataLoggerArchiveEntries = new TimedRequest(INTERVAL.MINUTE, 'getDataLoggerArchiveEntries', '', thisClass.setDataLoggerArchiveEntries, thisClass);
    } else {
      mainSite.timer.getDataLoggerArchiveEntries.timeout = INTERVAL.MINUTE;
    }
    mainSite.timer.getDataLoggerArchiveEntries.addCallbackFunction(thisClass.update);
    mainSite.timer.getDataLoggerArchiveEntries.oneShot();
    mainSite.timer.getDataLoggerArchiveEntries.resetTimeout();
  }

  this.update = function() {
    if (thisClass.visible) {
      //update data in site
      for (var i = 0; i < thisClass.dataBindings.length; i++) {
        thisClass.dataBindings[i]();
      }
    }
  };
}
DataLoggerPage.prototype = new PageTemplate();
DataLoggerPage.prototype.constructor = DataLoggerPage;
/*
 * ##################################################### End DataLoggerPage #####################################################
 */
/*
 * ##################################################### Start StatusPage Addon #####################################################
 */
StatusPage.prototype.portalConnectionState = undefined;
StatusPage.prototype.appendDOMFragmentSda_portalConnectionState = function(parentElement) {
  var elem = document.createElement('b');
  elem.appendChild(document.createTextNode(i18n.translate('sda_portal_connection') + ': '));
  parentElement.appendChild(elem);
  parentElement.appendChild(document.createElement('br'));
  var textNode = document.createTextNode(i18n.translate('n/a'));
  parentElement.appendChild(textNode);
  parentElement.appendChild(document.createElement('br'));

  var thisClass = this;
  thisClass.dataBindings.push(
    function() {
      if (thisClass.portalConnectionState == undefined) {
        return;
      }
      textNode.nodeValue = thisClass.portalConnectionState.ConnectionStatus[1] + ' (' + thisClass.portalConnectionState.ConnectionStatus[0] + ')';
      if (thisClass.portalConnectionState.ConnectionStatus[0] != 0) {
        textNode.nodeValue += ' - ' + i18n.translate('last_connect_error') + ': ' + thisClass.portalConnectionState.ConnectionError[1] + ' (' + thisClass.portalConnectionState.ConnectionError[0] + ')';
      }
    }
  );

  if (!mainSite.timer.getPortalConnectionState) {
    mainSite.timer.getPortalConnectionState = new TimedRequest(INTERVAL.MINUTE, 'getPortalConnectionState', '', function(response) {
      if (response == undefined) {
        //TODO: $('#message').text(i18n.translate('something_wrong') + ' ' + i18n.translate('device_unavailable'));
      } else if (response.error) {
        //TODO: $('#message').text(i18n.translate('error_message') + ': ' + response.error);
      } else {
        thisClass.portalConnectionState = response.data;
      }
    }, thisClass);
    mainSite.timer.getPortalConnectionState.addCallbackFunction(thisClass.update);
  }
  mainSite.timer.getPortalConnectionState.oneShot();
  mainSite.timer.getPortalConnectionState.resetTimeout();
}

StatusPage.prototype.buildInfo = undefined;
StatusPage.prototype.appendDOMFragmentSda_buildinfoTo = function(parentElement) {
  var elem = document.createElement('b');
  elem.appendChild(document.createTextNode(i18n.translate('sda_software') + ':'));
  parentElement.appendChild(elem);

  parentElement.appendChild(document.createElement('br'));
  var textNode = document.createTextNode(i18n.translate('n/a'));
  parentElement.appendChild(textNode);
  parentElement.appendChild(document.createElement('br'));

  var thisClass = this;
  thisClass.dataBindings.push(
    function() {
      if (thisClass.buildInfo == undefined) {
        return;
      }
      textNode.nodeValue = thisClass.buildInfo.buildInfo;
    }
  );

  if (!mainSite.timer.getBuildInfo) {
    mainSite.timer.getBuildInfo = new TimedRequest(INTERVAL.MINUTE, 'getBuildInfo', '', function(response) {
      if (response == undefined) {
        //TODO: $('#message').text(i18n.translate('something_wrong') + ' ' + i18n.translate('device_unavailable'));
      } else if (response.error) {
        //TODO: $('#message').text(i18n.translate('error_message') + ': ' + response.error);
      } else {
        thisClass.buildInfo = response.data;
      }
    }, thisClass);
    mainSite.timer.getBuildInfo.addCallbackFunction(thisClass.update);
  }
  mainSite.timer.getBuildInfo.oneShot();
  mainSite.timer.getBuildInfo.resetTimeout();
}

StatusPage.prototype.connectorID = undefined;
StatusPage.prototype.appendDOMFragmentServiceIdTo = function(parentElement) {
  var elem = document.createElement('b');
  elem.appendChild(document.createTextNode(i18n.translate('service_id') + ':'));
  parentElement.appendChild(elem)
  parentElement.appendChild(document.createElement('br'));
  var textNode = document.createTextNode(i18n.translate('n/a'));
  parentElement.appendChild(textNode);
  parentElement.appendChild(document.createElement('br'));

  var thisClass = this;
  thisClass.dataBindings.push(
    function() {
      if (thisClass.connectorID == undefined) {
        return;
      }
      textNode.nodeValue = thisClass.connectorID.connectorid;
    }
  );

  if (!mainSite.timer.getConnectorID) {
    mainSite.timer.getConnectorID = new TimedRequest(INTERVAL.MINUTE, 'getConnectorID', '', function(response) {
      if (response == undefined) {
        //TODO: $('#message').text(i18n.translate('something_wrong') + ' ' + i18n.translate('device_unavailable'));
      } else if (response.error) {
        //TODO: $('#message').text(i18n.translate('error_message') + ': ' + response.error);
      } else {
        thisClass.connectorID = response.data;
      }
    }, thisClass);
    mainSite.timer.getConnectorID.addCallbackFunction(thisClass.update);
  }
  mainSite.timer.getConnectorID.oneShot();
  mainSite.timer.getConnectorID.resetTimeout();
}

StatusPage.prototype.appendDOMFragmentCOInfosTo = function(parentElement) {
  var span = document.createElement('span');
  span.setAttribute('hidden', '');
  var thisClass = this;
  thisClass.dataBindings.push(
    function() {
      if (mainSite.deviceInfo && mainSite.deviceInfo.EtsDownload) {
        span.removeAttribute('hidden');
      } else {
        span.setAttribute('hidden', '');
      }
    }
  );
  parentElement.appendChild(span);
  parentElement = span;
  var elem = document.createElement('b');
  elem.appendChild(document.createTextNode(i18n.translate('grant_access_states') + ':'));
  parentElement.appendChild(elem)

  parentElement.appendChild(document.createElement('br'));

  var grandRemoteAccessCO = 2;
  this.appendDOMFragmentKimCoInfoTo(parentElement, grandRemoteAccessCO);

  parentElement.appendChild(document.createElement('br'));

  var grandResidentsRemoteAccessCO = 4;
  this.appendDOMFragmentKimCoInfoTo(parentElement, grandResidentsRemoteAccessCO);

  parentElement.appendChild(document.createElement('br'));

  var grandInstallersRemoteAccessCO = 6;
  this.appendDOMFragmentKimCoInfoTo(parentElement, grandInstallersRemoteAccessCO);

  parentElement.appendChild(document.createElement('br'));

  if (StatusPage.prototype.disableQuickConnect && StatusPage.prototype.disableQuickConnect === true) {
  } else {
    var grandQuickAccessRemoteAccessCO = 8;
    this.appendDOMFragmentKimCoInfoTo(parentElement, grandQuickAccessRemoteAccessCO);
  }

  parentElement.appendChild(document.createElement('br'));

  elem = document.createElement('b');
  elem.appendChild(document.createTextNode(i18n.translate('connection_states') + ':'));
  parentElement.appendChild(elem)

  parentElement.appendChild(document.createElement('br'));

  var statePortalConnectionCO = 20;
  this.appendDOMFragmentKimCoInfoTo(parentElement, statePortalConnectionCO);

  parentElement.appendChild(document.createElement('br'));

  var stateAnyRemoteConnectionCO = 21;
  this.appendDOMFragmentKimCoInfoTo(parentElement, stateAnyRemoteConnectionCO);

  parentElement.appendChild(document.createElement('br'));

  var stateResidentsRemoteConnectionCO = 22;
  this.appendDOMFragmentKimCoInfoTo(parentElement, stateResidentsRemoteConnectionCO);

  parentElement.appendChild(document.createElement('br'));
  var stateInstallersRemoteConnectionCO = 23;
  this.appendDOMFragmentKimCoInfoTo(parentElement, stateInstallersRemoteConnectionCO);

  parentElement.appendChild(document.createElement('br'));
  if (StatusPage.prototype.disableQuickConnect && StatusPage.prototype.disableQuickConnect === true) {
  } else {
    var stateQuickConnectRemoteConnectionCO = 24;
    this.appendDOMFragmentKimCoInfoTo(parentElement, stateQuickConnectRemoteConnectionCO);
  }

  parentElement.appendChild(document.createElement('br'));

  elem = document.createElement('b');
  elem.appendChild(document.createTextNode(i18n.translate('general_information') + ':'));
  parentElement.appendChild(elem)

  parentElement.appendChild(document.createElement('br'));

  var errorIndicationCO = 30;
  this.appendDOMFragmentKimCoInfoTo(parentElement, errorIndicationCO);

  parentElement.appendChild(document.createElement('br'));
  var portalConnectionInfoCO = 31;
  this.appendDOMFragmentKimCoInfoTo(parentElement, portalConnectionInfoCO);

  parentElement.appendChild(document.createElement('br'));
  var connectionErrorInfoCO = 32;
  this.appendDOMFragmentKimCoInfoTo(parentElement, connectionErrorInfoCO);

  parentElement.appendChild(document.createElement('br'));
  var thisClass = this;

}

StatusPage.prototype.prepareAppInfo = function(divAppInfomation) {
  headerAppInformation = document.createElement('h3');
  headerAppInformation.setAttribute('class', 'h3');
  headerAppInformation.appendChild(document.createTextNode(i18n.translate('sda_application_information')));
  divAppInfomation.appendChild(headerAppInformation);

  var fragmentAppState = document.createElement('span');
  fragmentAppState.setAttribute('hidden', '');
  divAppInfomation.appendChild(fragmentAppState);
  this.appendDOMFragmentAppStateTo(fragmentAppState);

  var thisClass = this;
  thisClass.dataBindings.push(
    function() {
      if (mainSite.deviceInfo && mainSite.deviceInfo.EtsDownload) {
        fragmentAppState.removeAttribute('hidden');
      } else {
        fragmentAppState.setAttribute('hidden', '');
      }
    }
  );

  this.appendDOMFragmentSda_portalConnectionState(divAppInfomation);

  divAppInfomation.appendChild(document.createElement('br'));

  this.appendDOMFragmentSda_buildinfoTo(divAppInfomation);

  divAppInfomation.appendChild(document.createElement('br'));

  this.appendDOMFragmentServiceIdTo(divAppInfomation);

  divAppInfomation.appendChild(document.createElement('br'));

  this.appendDOMFragmentCOInfosTo(divAppInfomation);

  divAppInfomation.appendChild(document.createElement('br'));
}

StatusPage.prototype.updateCO = function(span, textNode, currentCO) {
  switch (currentCO.id) {
    case 31:
      textNode.nodeValue = i18n.translate(currentCO.value);
      if (currentCO.value == 'Connected' || currentCO.value == 'True') {
        span.setAttribute('class', 'text--success');
      } else if (currentCO.value) {
        span.setAttribute('class', 'text--error');
      }
      break;
    case 32:
      textNode.nodeValue = i18n.translate(currentCO.value);
      if (currentCO.value == 'None' || currentCO.value == 'False') {
        span.setAttribute('class', 'text--success');
      } else if (currentCO.value) {
        span.setAttribute('class', 'text--error');
      }
      break;
    default:
      if (currentCO.value == '1') {
        span.setAttribute('class', 'text--success');
        textNode.nodeValue = i18n.translate('True');
      } else if (currentCO.value == '0') {
        span.setAttribute('class', 'text--error');
        textNode.nodeValue = i18n.translate('False');
      }
      break;
  }
}
/*
 * ##################################################### End StatusPage Addon #####################################################
 */
