/*
 * ##################################################### Start Product Addon #####################################################
 */

// Add product specific setting here. Product specific settings are superior to manufacturer settings.
 
MainSite.prototype.configureProductSettings = function() {
  this.kimFriendlyName = 'Gira S1';
} 

NetworkSettingsPage.prototype.configureProductSettings = function() {
  this.allowDisableNtp = false;
}

LoginPage.prototype.configureProductSettings = function() {
  this.enableGpaUser = false;
}

StatusPage.prototype.disableQuickConnect = true;

/*
 * ##################################################### End Product Addon #####################################################
 */

 /*
 * ##################################################### Start MainSite Addon #####################################################
 */

MainSite.prototype.addProductTopNavMenuItems = function() {
  this.pages['LoginPage'] = new LoginPage();

  this.headerMenu = ((new Menu(new MenuItem('logout', 'LogoutPage'))));
  this.headerMenu.add(new MenuItem('login', 'LoginPage'));
  this.pages['LogoutPage'] = new LogoutPage();

  this.headerMenu.add(new MenuItem('change_password', 'ChangePasswordPage'));
  this.pages['ChangePasswordPage'] = new ChangePasswordPage();

  this.menu.insertAfter(new MenuItem('diagnostic_page', 'DiagnosticPage'), this.menu.firmware_update);
  this.pages['DiagnosticPage'] = new ExternalLink(GetHttpsURL(window.location.host, 4433, '/discovery/presentation'));

  this.menu.insertAfter(new MenuItem('change_settings', 'NetworkSettingsPage'), this.menu.device_status);
  this.pages['NetworkSettingsPage'] = new NetworkSettingsPage();
  this.pages['NetworkSettingsPage'].ipSettingsFormEnabled = true;
  this.pages['NetworkSettingsPage'].ntpSettingsFormEnabled = true;

  this.menu.insertAfter(new MenuItem('data_logger', 'DataLoggerPage'), this.menu.device_status);
  this.pages['DataLoggerPage'] = new DataLoggerPage();
}

/*
 * ##################################################### End MainSite Addon #####################################################
 */
